var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var _ECOptionElement_id, _ECOptionElement_renderer, _ECOptionElement_nextTick;
import { toCamelCase, uniqueID } from 'web-utility';
import { EChartsElement } from './renderers/core';
import { ProxyElement } from './Proxy';
import { streamRequest, unwrapEventHandler, wrapEventHandler } from './utility';
export class ECOptionElement extends ProxyElement {
    constructor() {
        super(...arguments);
        _ECOptionElement_id.set(this, uniqueID());
        _ECOptionElement_renderer.set(this, void 0);
        _ECOptionElement_nextTick.set(this, void 0);
        Object.defineProperty(this, "emitOption", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: streamRequest()
        });
        Object.defineProperty(this, "emitAddListener", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: streamRequest()
        });
        Object.defineProperty(this, "emitRemoveListener", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: streamRequest()
        });
    }
    get chartTagName() {
        return toCamelCase(this.tagName.replace(/^ec-/i, '').toLowerCase());
    }
    get isSeries() {
        return this.chartTagName.endsWith('Chart');
    }
    get chartName() {
        return this.isSeries ? this.chartTagName.replace(/Chart$/, '') : null;
    }
    get eventSelector() {
        return [
            this.isSeries && 'series',
            this.chartName || this.chartTagName,
            this['type']
        ]
            .filter(Boolean)
            .join('.');
    }
    connectedCallback() {
        if (__classPrivateFieldGet(this, _ECOptionElement_renderer, "f"))
            return;
        super.connectedCallback();
        if (!this.attributes[0])
            this.updateOption();
        for (let parent = this.parentElement; parent; parent = parent.parentElement)
            if (parent instanceof EChartsElement)
                __classPrivateFieldSet(this, _ECOptionElement_renderer, parent, "f");
        if (!__classPrivateFieldGet(this, _ECOptionElement_renderer, "f"))
            throw new ReferenceError(`<${this.tagName.toLowerCase()} /> should be append to a DOM tree within <ec-svg-renderer /> or <ec-canvas-renderer />`);
        __classPrivateFieldGet(this, _ECOptionElement_renderer, "f").connectOption(this.emitOption.stream);
        __classPrivateFieldGet(this, _ECOptionElement_renderer, "f").connectRemoveListener(this.emitRemoveListener.stream);
        __classPrivateFieldGet(this, _ECOptionElement_renderer, "f").connectAddListener(this.emitAddListener.stream);
    }
    setProperty(key, value) {
        var _a;
        super.setProperty(key, value);
        __classPrivateFieldSet(this, _ECOptionElement_nextTick, (_a = __classPrivateFieldGet(this, _ECOptionElement_nextTick, "f")) !== null && _a !== void 0 ? _a : Promise.resolve().then(() => {
            this.updateOption();
            __classPrivateFieldSet(this, _ECOptionElement_nextTick, null, "f");
        }), "f");
    }
    updateOption() {
        const data = this.toJSON(), { formatter } = this;
        const option = (this.isSeries
            ? { series: [Object.assign(Object.assign({ id: __classPrivateFieldGet(this, _ECOptionElement_id, "f") }, data), { type: this.chartName })] }
            : { [this.chartTagName]: Object.assign(Object.assign({}, data), { formatter }) });
        return this.emitOption(option);
    }
    addEventListener(name, handler) {
        return this.emitAddListener(name, this.eventSelector, wrapEventHandler.call(this, name, handler));
    }
    removeEventListener(event, handler) {
        return this.emitRemoveListener(event, unwrapEventHandler(handler));
    }
}
_ECOptionElement_id = new WeakMap(), _ECOptionElement_renderer = new WeakMap(), _ECOptionElement_nextTick = new WeakMap();
//# sourceMappingURL=Option.js.map