var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _ProxyElement_data;
import { parseJSON, proxyPrototype, toCamelCase, toHyphenCase } from 'web-utility';
import { EventKeyPattern } from './utility';
export class ProxyElement extends HTMLElement {
    toJSON() {
        return Object.fromEntries(Object.entries(__classPrivateFieldGet(this, _ProxyElement_data, "f")).filter(([key, value]) => typeof value !== 'function' && !key.startsWith('__react')));
    }
    constructor() {
        super();
        _ProxyElement_data.set(this, {});
        proxyPrototype(this, __classPrivateFieldGet(this, _ProxyElement_data, "f"), (key, value) => this.setProperty(key.toString(), value));
    }
    connectedCallback() {
        const prototype = Object.getPrototypeOf(this);
        const customAttributes = [...this.attributes].filter(({ name }) => !(name in prototype));
        if (customAttributes[0] && !Object.keys(this.toJSON())[0])
            for (const { name, value } of customAttributes)
                this.setAttribute(name, value);
    }
    setProperty(key, value) {
        const oldValue = __classPrivateFieldGet(this, _ProxyElement_data, "f")[key], name = toHyphenCase(key), eventName = key.slice(2);
        __classPrivateFieldGet(this, _ProxyElement_data, "f")[key] = value;
        switch (typeof value) {
            case 'object':
                if (!value)
                    this.removeAttribute(name);
                break;
            case 'boolean':
                if (value)
                    super.setAttribute(name, name + '');
                else
                    super.removeAttribute(name);
                break;
            case 'function':
                if (EventKeyPattern.test(key)) {
                    this.removeEventListener(eventName, oldValue);
                    this.addEventListener(eventName, value);
                }
                break;
            default:
                if (value != null)
                    super.setAttribute(name, typeof value === 'string'
                        ? value
                        : JSON.stringify(value));
                else if (EventKeyPattern.test(key) &&
                    typeof oldValue === 'function')
                    this.removeEventListener(eventName, value);
                else
                    super.removeAttribute(name);
        }
    }
    setAttribute(name, value) {
        super.setAttribute(name, value);
        const key = toCamelCase(name);
        if (key in Object.getPrototypeOf(this))
            return;
        this[key] = name === value || parseJSON(value);
    }
}
_ProxyElement_data = new WeakMap();
//# sourceMappingURL=Proxy.js.map