var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var _EChartsElement_instances, _EChartsElement_core, _EChartsElement_coreDefer, _EChartsElement_init;
import { init } from 'echarts/core';
import { debounce } from 'lodash';
import { parseDOM } from 'web-utility';
import { ProxyElement } from '../Proxy';
import { streamRequest, unwrapEventHandler, wrapEventHandler } from '../utility';
export class EChartsElement extends ProxyElement {
    get renderer() {
        const [_, type] = this.tagName.toLowerCase().split('-');
        return type;
    }
    get options() {
        return __classPrivateFieldGet(this, _EChartsElement_core, "f").getOption();
    }
    constructor() {
        super();
        _EChartsElement_instances.add(this);
        _EChartsElement_core.set(this, void 0);
        _EChartsElement_coreDefer.set(this, Promise.withResolvers());
        Object.defineProperty(this, "setOption", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: streamRequest()
        });
        Object.defineProperty(this, "connectOption", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: this.connectChildStream((option) => this.setOption(option))
        });
        Object.defineProperty(this, "connectAddListener", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: this.connectChildStream((event, selector, handler) => {
                __classPrivateFieldGet(this, _EChartsElement_core, "f").on(event, selector, handler);
            })
        });
        Object.defineProperty(this, "connectRemoveListener", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: this.connectChildStream((event, handler) => {
                __classPrivateFieldGet(this, _EChartsElement_core, "f").off(event, handler);
            })
        });
        Object.defineProperty(this, "addEventListener", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: streamRequest()
        });
        Object.defineProperty(this, "removeEventListener", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: streamRequest()
        });
        Object.defineProperty(this, "handleResize", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: debounce(() => __classPrivateFieldGet(this, _EChartsElement_core, "f").resize(this.toJSON().resizeOptions))
        });
        this.attachShadow({ mode: 'open' }).append(parseDOM('<div style="height: 100%" />')[0]);
    }
    connectedCallback() {
        var _a;
        if (__classPrivateFieldGet(this, _EChartsElement_core, "f"))
            return;
        super.connectedCallback();
        this.style.display = 'block';
        __classPrivateFieldGet(this, _EChartsElement_instances, "m", _EChartsElement_init).call(this);
        (_a = globalThis.addEventListener) === null || _a === void 0 ? void 0 : _a.call(globalThis, 'resize', this.handleResize);
    }
    disconnectedCallback() {
        var _a, _b;
        (_a = globalThis.removeEventListener) === null || _a === void 0 ? void 0 : _a.call(globalThis, 'resize', this.handleResize);
        (_b = __classPrivateFieldGet(this, _EChartsElement_core, "f")) === null || _b === void 0 ? void 0 : _b.dispose();
        __classPrivateFieldSet(this, _EChartsElement_core, undefined, "f");
    }
    setProperty(key, value) {
        super.setProperty(key, value);
        this.setOption(this.toJSON());
    }
    processStream(stream, executor, context) {
        return __awaiter(this, void 0, void 0, function* () {
            var _a, stream_1, stream_1_1;
            var _b, e_1, _c, _d;
            yield __classPrivateFieldGet(this, _EChartsElement_coreDefer, "f").promise;
            try {
                for (_a = true, stream_1 = __asyncValues(stream); stream_1_1 = yield stream_1.next(), _b = stream_1_1.done, !_b; _a = true) {
                    _d = stream_1_1.value;
                    _a = false;
                    const request = _d;
                    const { input, output } = request;
                    try {
                        const data = executor.apply(context, input);
                        output.resolve(data);
                    }
                    catch (error) {
                        output.reject(error);
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (!_a && !_b && (_c = stream_1.return)) yield _c.call(stream_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        });
    }
    connectChildStream(executor) {
        const that = this;
        return function (stream) {
            return that.processStream(stream, executor, this);
        };
    }
}
_EChartsElement_core = new WeakMap(), _EChartsElement_coreDefer = new WeakMap(), _EChartsElement_instances = new WeakSet(), _EChartsElement_init = function _EChartsElement_init() {
    var _a = this.toJSON(), { theme, initOptions, setOptions } = _a, props = __rest(_a, ["theme", "initOptions", "setOptions"]);
    __classPrivateFieldSet(this, _EChartsElement_core, init(this.shadowRoot.firstElementChild, theme, Object.assign(Object.assign({}, initOptions), { renderer: this.renderer })), "f");
    __classPrivateFieldGet(this, _EChartsElement_coreDefer, "f").resolve();
    // @ts-ignore
    this.setOption(Object.assign({ grid: {} }, props));
    this.processStream(this.setOption.stream, (data) => {
        __classPrivateFieldGet(this, _EChartsElement_core, "f").setOption(data, Object.assign({ notMerge: false, lazyUpdate: true }, setOptions));
    });
    this.processStream(this.removeEventListener.stream, (event, handler) => {
        __classPrivateFieldGet(this, _EChartsElement_core, "f").getZr().off(event, unwrapEventHandler(handler));
    });
    this.processStream(this.addEventListener.stream, (name, handler) => {
        __classPrivateFieldGet(this, _EChartsElement_core, "f")
            .getZr()
            .on(name, wrapEventHandler.call(this, name, handler));
    });
};
//# sourceMappingURL=core.js.map