import { ECElementEvent } from 'echarts/core';
import { ReadableStream } from 'web-streams-polyfill';
export interface StreamRequest<I extends any[], O = void> {
    context?: object;
    input: I;
    output: PromiseWithResolvers<O>;
}
export declare function streamRequest<I extends any[], O = void>(): ((...input: I) => Promise<O>) & {
    stream: ReadableStream<StreamRequest<I, O>>;
};
export declare const EventKeyPattern: RegExp;
export type ZRElementEventName = ECElementEvent['type'];
export type ZRElementEventHandler = (event: ECElementEvent) => boolean | void;
export declare function wrapEventHandler(this: EventTarget, name: string, handler: EventListener): ZRElementEventHandler;
export declare const unwrapEventHandler: (handler: EventListener) => ZRElementEventHandler;
