import { ReadableStream } from 'web-streams-polyfill';
export function streamRequest() {
    var handler;
    const stream = new ReadableStream({
        start: controller => {
            handler = controller;
        }
    });
    function call(...input) {
        const request = {
            context: this,
            input,
            output: Promise.withResolvers()
        };
        handler.enqueue(request);
        return request.output.promise;
    }
    return Object.assign(call, { stream });
}
export const EventKeyPattern = /^on(\w+)/;
const EventHandlerMap = new WeakMap();
export function wrapEventHandler(name, handler) {
    const wrapper = detail => {
        const event = new CustomEvent(name, { detail }), meta = { enumerable: true, value: this };
        Object.defineProperties(event, {
            eventPhase: Object.assign(Object.assign({}, meta), { value: Event.AT_TARGET }),
            srcElement: meta,
            target: meta,
            currentTarget: meta
        });
        handler.call(this, event);
    };
    EventHandlerMap.set(handler, wrapper);
    return wrapper;
}
export const unwrapEventHandler = (handler) => EventHandlerMap.get(handler);
//# sourceMappingURL=utility.js.map